// ._____________________________________________________________________.
// |   _   .   .   _   _____   _   .___     ___    _   .   . .____ .___  |
// |  / \  |   |  / \    |    / \  |   \   /   \  / \  |   | |     |   \ |
// | {---} {   } {---}   |   {---} |___/   \___  {---} {   } |__   |___/ |
// | |   |  \ /  |   |   |   |   | |  \        \ |   |  \ /  |     |  \  |
// | |   |   V   |   |   |   |   | |   \   \___/ |   |   V   |____ |   \ |
// |_____________________________________________________________________|
// |                                                                     |
// |   Build 3.0.1                    Scripted by Xalos (BL_ID: 11239)   |
// |   File Details: Avatar IO conversion handler; required for...       |
// |      - Avatar Saver Online Server                                   |
// |      - Compact Avatar Saving file format                            |
// |_____________________________________________________________________|

//Byte Array SO
function ByteArraySO::FromString(%this, %string)
{
	%asciiMap = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
	for(%i=0;%i<strLen(%string);%i++)
		%this.byte[%i] = strPos(%asciiMap, getSubStr(%string, %i, 1)) + 32;
	%this.bytes = strLen(%string);
	return %this;
}

function ByteArraySO::ToString(%this)
{
	%asciiMap = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
	for(%i=0;%i<%this.bytes;%i++)
		if(%this.byte[%i] - 32 >= 0)
			%string = %string @ getSubStr(%asciiMap, %this.byte[%i] - 32, 1);
	return %string;
}

//Yes, I am aware that Base64 is the preferred format, but it just seems derpy and stupid to deliberately pad something that you already know the length of.
function ByteArraySO::FromRadix64(%this, %string)
{
	%this.bytes = 0;
	%radix64 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+-";
	for(%i=0;%i<strLen(%string);%i++)
	{
		if((%byte = strPos(%radix64, getSubStr(%string, %i, 1))) == -1) continue;
		%bit[-1+%bits++] = (%byte & 32) != 0;
		%bit[-1+%bits++] = (%byte & 16) != 0;
		%bit[-1+%bits++] = (%byte & 8) != 0;
		%bit[-1+%bits++] = (%byte & 4) != 0;
		%bit[-1+%bits++] = (%byte & 2) != 0;
		%bit[-1+%bits++] = (%byte & 1) != 0;
		if(%bits >= 8)
		{
			%byte = %bit0 * 128 + %bit1 * 64 + %bit2 * 32 + %bit3 * 16
				+ %bit4 * 8 + %bit5 * 4 + %bit6 * 2 + %bit7;
			%this.byte[-1+%this.bytes++] = %byte; %bits -= 8;
			for(%j=0;%j<%bits;%j++) %bit[%j] = %bit[%j + 8];
		}
	}
	return %this;
}

function ByteArraySO::ToRadix64(%this)
{
	%radix64 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+-";
	for(%i=0;%i<%this.bytes;%i++)
	{
		%byte = %this.byte[%i];
		%bit[-1+%bits++] = (%byte & 128) != 0;
		%bit[-1+%bits++] = (%byte & 64) != 0;
		%bit[-1+%bits++] = (%byte & 32) != 0;
		%bit[-1+%bits++] = (%byte & 16) != 0;
		%bit[-1+%bits++] = (%byte & 8) != 0;
		%bit[-1+%bits++] = (%byte & 4) != 0;
		%bit[-1+%bits++] = (%byte & 2) != 0;
		%bit[-1+%bits++] = (%byte & 1) != 0;
		while(%bits >= 6)
		{
			%string = %string @ getSubStr(%radix64, %bit0 * 32 + %bit1 * 16 + %bit2 * 8 + %bit3 * 4 + %bit4 * 2 + %bit5, 1);
			%bits -= 6; for(%j=0;%j<%bits;%j++) %bit[%j] = %bit[%j + 6];
		}
	}
	if(%bits > 0)
	{
		for(%i=%bits;%i<%bits+6;%i++) %bit[%i] = 0;
		%string = %string @ getSubStr(%radix64, %bit0 * 32 + %bit1 * 16 + %bit2 * 8 + %bit3 * 4 + %bit4 * 2 + %bit5, 1);
	}
	return %string;
}

//Avatar SO
function AvatarSO::getCurrentAvatar(%this)
{
	//Body parts
	%this.accent = $Pref::Avatar::Accent;
	%this.chest = $Pref::Avatar::Chest;
	%this.hat = $Pref::Avatar::Hat;
	%this.hip = $Pref::Avatar::Hip;
	%this.lArm = $Pref::Avatar::LArm;
	%this.lHand = $Pref::Avatar::LHand;
	%this.lLeg = $Pref::Avatar::LLeg;
	%this.pack = $Pref::Avatar::Pack;
	%this.rArm = $Pref::Avatar::RArm;
	%this.rHand = $Pref::Avatar::RHand;
	%this.rLeg = $Pref::Avatar::RLeg;
	%this.secondPack = $Pref::Avatar::SecondPack;
	%this.symmetry = $Pref::Avatar::Symmetry;
	
	//Body colors
	%this.accentColor = $Pref::Avatar::AccentColor;
	%this.hatColor = $Pref::Avatar::HatColor;
	%this.headColor = $Pref::Avatar::HeadColor;
	%this.hipColor = $Pref::Avatar::HipColor;
	%this.lArmColor = $Pref::Avatar::LArmColor;
	%this.lHandColor = $Pref::Avatar::LHandColor;
	%this.lLegColor = $Pref::Avatar::LLegColor;
	%this.packColor = $Pref::Avatar::PackColor;
	%this.rArmColor = $Pref::Avatar::RArmColor;
	%this.rHandColor = $Pref::Avatar::RHandColor;
	%this.rLegColor = $Pref::Avatar::RLegColor;
	%this.secondPackColor = $Pref::Avatar::SecondPackColor;
	%this.torsoColor = $Pref::Avatar::TorsoColor;
	
	//Decal names
	%this.decalName = $Pref::Avatar::DecalName;
	%this.faceName = $Pref::Avatar::FaceName;
}

function AvatarSO::setCurrentAvatar(%this)
{
	//Body parts
	$Pref::Avatar::Accent = %this.accent;
	$Pref::Avatar::Chest = %this.chest;
	$Pref::Avatar::Hat = %this.hat;
	$Pref::Avatar::Hip = %this.hip;
	$Pref::Avatar::LArm = %this.lArm;
	$Pref::Avatar::LHand = %this.lHand;
	$Pref::Avatar::LLeg = %this.lLeg;
	$Pref::Avatar::Pack = %this.pack;
	$Pref::Avatar::RArm = %this.rArm;
	$Pref::Avatar::RHand = %this.rHand;
	$Pref::Avatar::RLeg = %this.rLeg;
	$Pref::Avatar::SecondPack = %this.secondPack;
	$Pref::Avatar::Symmetry = %this.symmetry;
	
	//Body colors
	$Pref::Avatar::AccentColor = %this.accentColor;
	$Pref::Avatar::HatColor = %this.hatColor;
	$Pref::Avatar::HeadColor = %this.headColor;
	$Pref::Avatar::HipColor = %this.hipColor;
	$Pref::Avatar::LArmColor = %this.lArmColor;
	$Pref::Avatar::LHandColor = %this.lHandColor;
	$Pref::Avatar::LLegColor = %this.lLegColor;
	$Pref::Avatar::PackColor = %this.packColor;
	$Pref::Avatar::RArmColor = %this.rArmColor;
	$Pref::Avatar::RHandColor = %this.rHandColor;
	$Pref::Avatar::RLegColor = %this.rLegColor;
	$Pref::Avatar::SecondPackColor = %this.secondPackColor;
	$Pref::Avatar::TorsoColor = %this.torsoColor;
	
	//Decal names
	$Pref::Avatar::DecalName = %this.decalName;
	$Pref::Avatar::FaceName = %this.faceName;
	clientcmdUpdatePrefs();
}

function AvatarSO::loadAvatar(%this, %name)
{
	if(!isAvatar(%name)) return 0;
	
	//Body parts
	%this.accent = $Avatars::Accent_[%name];
	%this.chest = $Avatars::Chest_[%name];
	%this.hat = $Avatars::Hat_[%name];
	%this.hip = $Avatars::Hip_[%name];
	%this.lArm = $Avatars::LArm_[%name];
	%this.lHand = $Avatars::LHand_[%name];
	%this.lLeg = $Avatars::LLeg_[%name];
	%this.pack = $Avatars::Pack_[%name];
	%this.rArm = $Avatars::RArm_[%name];
	%this.rHand = $Avatars::RHand_[%name];
	%this.rLeg = $Avatars::RLeg_[%name];
	%this.secondPack = $Avatars::SecondPack_[%name];
	%this.symmetry = $Avatars::Symmetry_[%name];
	
	//Body colors
	%this.accentColor = $Avatars::AccentColor_[%name];
	%this.hatColor = $Avatars::HatColor_[%name];
	%this.headColor = $Avatars::HeadColor_[%name];
	%this.hipColor = $Avatars::HipColor_[%name];
	%this.lArmColor = $Avatars::LArmColor_[%name];
	%this.lHandColor = $Avatars::LHandColor_[%name];
	%this.lLegColor = $Avatars::LLegColor_[%name];
	%this.packColor = $Avatars::PackColor_[%name];
	%this.rArmColor = $Avatars::RArmColor_[%name];
	%this.rHandColor = $Avatars::RHandColor_[%name];
	%this.rLegColor = $Avatars::RLegColor_[%name];
	%this.secondPackColor = $Avatars::SecondPackColor_[%name];
	%this.torsoColor = $Avatars::TorsoColor_[%name];
	
	//Decal names
	%this.decalName = $Avatars::DecalName_[%name];
	%this.faceName = $Avatars::FaceName_[%name];
	
	return 1;
}

function AvatarSO::saveAvatar(%this, %name, %noSave)
{
	//Body parts
	$Avatars::Accent_[%name] = %this.accent;
	$Avatars::Chest_[%name] = %this.chest;
	$Avatars::Hat_[%name] = %this.hat;
	$Avatars::Hip_[%name] = %this.hip;
	$Avatars::LArm_[%name] = %this.lArm;
	$Avatars::LHand_[%name] = %this.lHand;
	$Avatars::LLeg_[%name] = %this.lLeg;
	$Avatars::Pack_[%name] = %this.pack;
	$Avatars::RArm_[%name] = %this.rArm;
	$Avatars::RHand_[%name] = %this.rHand;
	$Avatars::RLeg_[%name] = %this.rLeg;
	$Avatars::SecondPack_[%name] = %this.secondPack;
	$Avatars::Symmetry_[%name] = %this.symmetry;
	
	//Body colors
	$Avatars::AccentColor_[%name] = %this.accentColor;
	$Avatars::HatColor_[%name] = %this.hatColor;
	$Avatars::HeadColor_[%name] = %this.headColor;
	$Avatars::HipColor_[%name] = %this.hipColor;
	$Avatars::LArmColor_[%name] = %this.lArmColor;
	$Avatars::LHandColor_[%name] = %this.lHandColor;
	$Avatars::LLegColor_[%name] = %this.lLegColor;
	$Avatars::PackColor_[%name] = %this.packColor;
	$Avatars::RArmColor_[%name] = %this.rArmColor;
	$Avatars::RHandColor_[%name] = %this.rHandColor;
	$Avatars::RLegColor_[%name] = %this.rLegColor;
	$Avatars::SecondPackColor_[%name] = %this.secondPackColor;
	$Avatars::TorsoColor_[%name] = %this.torsoColor;
	
	//Decal names
	$Avatars::DecalName_[%name] = %this.decalName;
	$Avatars::FaceName_[%name] = %this.faceName;
	
	for(%i=0;%i<$Avatars::Avatars;%i++)
		if($Avatars::AvatarName[%i] $= %name)
			%shift++;
		else
			$Avatars::AvatarName[%i - %shift] = $Avatars::AvatarName[%i];
	$Avatars::Avatars -= %shift;
	$Avatars::IsAvatar_[%name] = 1;
	$Avatars::AvatarName[-1+$Avatars::Avatars++] = %name;
	AvatarSaver_tryUpdating();
	if(!%noSave) saveAvatarSaveFile();
	return 1;
}

//Avatar encoding
function AvatarSO::EncodeData(%avatar)
{
	%array = new ScriptObject() { class = "ByteArraySO"; };
	%array.bytes = 57;
	%array.byte0 = ((%avatar.accent & 3) << 6) | ((%avatar.chest & 1) << 5) | ((%avatar.hat & 7) << 1) | (%avatar.hip & 1);
	%array.byte1 = ((%avatar.lArm & 1) << 7) | ((%avatar.lHand & 1) << 6) | ((%avatar.lLeg & 1) << 5)
		| (($Pref::Avatar::pack & 7) << 2) | ((%avatar.rArm & 1) << 1) | (%avatar.rHand & 1);
	%array.byte2 = ((%avatar.rLeg & 1) << 7) | ((%avatar.secondPack & 7) << 4) | ((%avatar.symmetry & 1) << 3);
	%color[-1+%colors++] = %avatar.accentColor;
	%color[-1+%colors++] = %avatar.hatColor;
	%color[-1+%colors++] = %avatar.headColor;
	%color[-1+%colors++] = %avatar.hipColor;
	%color[-1+%colors++] = %avatar.lArmColor;
	%color[-1+%colors++] = %avatar.lHandColor;
	%color[-1+%colors++] = %avatar.lLegColor;
	%color[-1+%colors++] = %avatar.packColor;
	%color[-1+%colors++] = %avatar.rArmColor;
	%color[-1+%colors++] = %avatar.rHandColor;
	%color[-1+%colors++] = %avatar.rLegColor;
	%color[-1+%colors++] = %avatar.secondPackColor;
	%color[-1+%colors++] = %avatar.torsoColor;
	for(%i=0;%i<%colors;%i++) for(%j=0;%j<4;%j++)
		%array.byte[3 + %j + (%i * 4)] = mFloatLength(getWord(%color[%i], %j) * 255, 0) & 255;
	%decal = %avatar.decalName; if(getSubStr(%decal, 0, 14) $= "Add-Ons/Decal_") %decal = getSubStr(%decal, 14, strLen(%decal) - 14);
	%face = %avatar.faceName; if(getSubStr(%face, 0, 13) $= "Add-Ons/Face_") %face = getSubStr(%face, 13, strLen(%face) - 13);
	%array.byte55 = strLen(%decal);
	%array.byte56 = strLen(%face);
	%val = %array.ToRadix64() @ %decal @ %face;
	%array.delete();
	return %val;
}

function AvatarSO::DecodeData(%avatar, %string)
{
	%data = getSubStr(%string, 0, 76);
	%decals = getSubStr(%string, 76, strLen(%string) - 76);
	%array = (new ScriptObject() { class = "ByteArraySO"; }).FromRadix64(%data);
	%byte = %array.byte0;
	%avatar.accent = (%byte & 192) >> 6;
	%avatar.chest = (%byte & 32) >> 5;
	%avatar.hat = (%byte & 14) >> 1;
	%avatar.hip = %byte & 1;
	%byte = %array.byte1;
	%avatar.lArm = (%byte & 128) >> 7;
	%avatar.lHand = (%byte & 64) >> 6;
	%avatar.lLeg = (%byte & 32) >> 5;
	%avatar.pack = (%byte & 28) >> 2;
	%avatar.rArm = (%byte & 2) >> 1;
	%avatar.rHand = %byte & 1;
	%byte = %array.byte2;
	%avatar.rLeg = (%byte & 128) >> 7;
	%avatar.secondPack = (%byte & 112) >> 4;
	%avatar.symmetry = (%byte & 8) >> 3;
	for(%i=0;%i<13;%i++)
		%color[%i] = (%array.byte[3+%i*4]/255) SPC (%array.byte[4+%i*4]/255) SPC (%array.byte[5+%i*4]/255) SPC (%array.byte[6+%i*4]/255);
	%avatar.accentColor = %color0; %avatar.hatColor = %color1; %avatar.headColor = %color2; %avatar.hipColor = %color3;
	%avatar.lArmColor = %color4; %avatar.lHandColor = %color5; %avatar.lLegColor = %color6;
	%avatar.packCOlor = %color7; %avatar.rArmColor = %color8; %avatar.rHandColor = %color9;
	%avatar.rLegColor = %color10; %avatar.secondPackColor = %color11; %avatar.torsoColor = %color12;
	%len0 = %array.byte55; %len1 = %array.byte56;
	%decal = getSubStr(%decals, 0, %len0); %face = getSubStr(%decals, %len0, %len1);
	if(isFile("Add-Ons/Decal_"@%decal)) %decal = "Add-Ons/Decal_"@%decal;
	if(isFile("Add-Ons/Face_"@%face)) %face = "Add-Ons/Face_"@%face;
	%avatar.decalName = %decal; %avatar.faceName = %face;
}

//Avatar Save File
function loadAvatarSaveFile()
{
	switch($Pref::AvatarSaver::SaveType)
	{
		case 0:
			if(isFile("config/client/Avatars.cs")) exec("config/client/Avatars.cs");
		case 1:
			%avatar = new ScriptObject() { class = "AvatarSO"; };
			(%file = new FileObject()).openForRead("config/client/Avatars.cs");
			while(!%file.isEOF())
			{
				%line = %file.readLine();
				%pos = strPos(%line, "\"", 1);
				if(%pos == -1) continue;
				while(getSubStr(%line, %pos - 1, 1) $= "\\")
				{
					%pos = strPos(%line, "\"", %pos + 1);
					if(%pos == -1) continue;
				}
				%name = getSubStr(%line, 1, %pos - 1);
				%data = getSubStr(%line, strLen(%name) + 4, strLen(%line) - (strLen(%name) + 5));
				%avatar.decodeData(%data); %avatar.saveAvatar(%name, 1);
			}
			%file.close(); %file.delete(); %avatar.delete();
	}
}

function saveAvatarSaveFile()
{
	switch($Pref::AvatarSaver::SaveType)
	{
		case 0:
			export("$Avatars::*", "config/client/Avatars.cs");
		case 1:
			%avatar = new ScriptObject() { class = "AvatarSO"; };
			(%file = new FileObject()).openForWrite("config/client/Avatars.cs");
			for(%i=0;%i<$Avatars::Avatars;%i++)
			{
				%name = $Avatars::AvatarName[%i]; %avatar.loadAvatar(%name);
				%name = strReplace(strReplace(%name, "\\", "\\\\"), "\"", "\\\"");
				%file.writeLine("\""@%name@"\": "@%avatar.encodeData());
			}
			%file.close(); %file.delete(); %avatar.delete();
	}
}