// ._____________________________________________________________________.
// |   _   .   .   _   _____   _   .___     ___    _   .   . .____ .___  |
// |  / \  |   |  / \    |    / \  |   \   /   \  / \  |   | |     |   \ |
// | {---} {   } {---}   |   {---} |___/   \___  {---} {   } |__   |___/ |
// | |   |  \ /  |   |   |   |   | |  \        \ |   |  \ /  |     |  \  |
// | |   |   V   |   |   |   |   | |   \   \___/ |   |   V   |____ |   \ |
// |_____________________________________________________________________|
// |                                                                     |
// |   Build 3.0.1                    Scripted by Xalos (BL_ID: 11239)   |
// |   File Details: Primary code file; required for the Avatar Saver.   |
// |_____________________________________________________________________|

if($Pref::AvatarSaver::ControlChar $= "")
	$Pref::AvatarSaver::ControlChar = "/";

package avatarSaver
{
	function NMH_type::send(%this)
	{
		%msg = %this.getValue();
		if(firstWord(%msg) $= ($Pref::AvatarSaver::ControlChar@"load"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(!isAvatar(%name))
				MessageBoxOK("Error!", "There is no avatar with that name!");
			else
			{
				loadAvatar(%name);
				forceSaveAvatar();
			}
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Pref::AvatarSaver::ControlChar@"save"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(%name $= "")
			{
				MessageBoxOK("Error!", "You have to put in a name to save!");
				%this.setValue("");
				Parent::send(%this);
				return;
			}
			if(isAvatar(%name))
				MessageBoxYesNo("Are you sure?", "Do you want to overwrite the avatar \""@%name@"\"?", "saveAvatar(\""@%name@"\");");
			else
				saveAvatar(%name);
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Pref::AvatarSaver::ControlChar@"delete"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(!isAvatar(%name))
				MessageBoxOK("Error!", "There is no avatar with that name!");
			else
				deleteAvatar(%name);
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Pref::AvatarSaver::ControlChar@"setChar"))
		{
			%char = restWords(%msg);
			if(strLen(%char) != 1)
			{
				if(%char $= "")
					MessageBoxOK("Error!", "You can't set the control character to be nothing!");
				else
					MessageBoxOK("Error!", "You can't set the control character to multiple characters!");
				%this.setValue("");
				Parent::send(%this);
				return;
			}
			%badChars = "qwertyuiopasdfghjklzxcvbnm 1234567890!@#$%^&*()\\\"";
			if(striPos(%badChars, %char) != -1)
			{
				%use = %char;
				if(%use $= "\"")%use = "\\\"";
				if(%use $= "\\")%use = "\\\\";
				MessageBoxYesNo("Are you sure?", "The character \""@%char@"\" is probably not one you want to use!\nDo you want to use it anyway?", "$Pref::AvatarSaver::ControlChar = \""@%use@"\";export(\"$Avatars::*\",\"config/client/avatars.cs\");");
			}
			$Pref::AvatarSaver::ControlChar = %char;
			export("$Avatars::*", "config/client/avatars.cs");
			%msg = "";
		}
		%this.setValue(%msg);
		Parent::send(%this);
	}
	function MessageCallback(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z)
	{
		
		Parent::MessageCallback(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z);
	}
};
activatePackage("avatarSaver");

function isAvatar(%name)
{
	if($Avatars::IsAvatar_[%name])
		return 1;
	return 0;
}

function forceSaveAvatar()
{
	%file = new fileObject(){};
	%file.openForRead("config/client/prefs.cs");
	while(!%file.isEOF())
		%line[-1+%lines++] = %file.readLine();
	%file.close();
	for(%i=0;%i<%lines;%i++)
		if(striPos(%line[%i], "$Pref::Avatar") == 0)
			%line[%i] = getWord(%line[%i], 0)@" = \""@eval("return "@getWord(%line[%i], 0)@";")@"\";";
	%file.openForWrite("config/client/prefs.cs");
	for(%i=0;%i<%lines;%i++)
		%file.writeLine(%line[%i]);
	%file.close();
	%file.delete();
}

function saveAvatar(%name)
{
	%avatar = new ScriptObject() { class = "AvatarSO"; };
	%avatar.getCurrentAvatar(); %avatar.saveAvatar(%name); %avatar.delete();
}

function loadAvatar(%name)
{
	%avatar = new ScriptObject() { class = "AvatarSO"; };
	%avatar.loadAvatar(%name); %avatar.setCurrentAvatar(); %avatar.delete();
}

function deleteAvatar(%name)
{
	if(!isAvatar(%name))
		return;
	for(%i=0;%i<$Avatars::Avatars;%i++)
		if($Avatars::AvatarName[%i] $= %name)
			%shift++;
		else
			$Avatars::AvatarName[%i - %shift] = $Avatars::AvatarName[%i];
	$Avatars::Avatars -= %shift;
	deleteVariables("$Avatars::*_"@%name);
	export("$Avatars::*", "config/client/avatars.cs");
	AvatarSaver_tryUpdating();
}

exec("./GUI.cs");
exec("./Editor.cs");
exec("./Avatar IO.cs");

//Possibly temporary stuff that might change
exec("./Temporary.cs");

loadAvatarSaveFile();

if(!$AvatarSaver::boundCommands)
{
	$AvatarSaver::boundCommands = 1;
	$remapDivision[$remapCount] = "Avatar Saver";
	$remapName[$remapCount] = "Toggle GUI";
	$remapCmd[$remapCount] = "toggleAvatarSaverGUI";
	$remapCount++;
}