if(!isObject(AvatarSaver_TransferButton))
	AvatarSaverUI.add(new GuiBitmapButtonCtrl(AvatarSaver_TransferButton)
	{
		position = "240 190";
		extent = "60 24";
		
		text = "Transfer";
		mColor = "153 153 153 255";
		
		bitmap = "base/client/ui/button1";
		profile = "BlockButtonProfile";
		command = "Canvas.pushDialog(AvatarSaver_TransferGUI);";
	});

if(isObject(AvatarSaver_TransferGUI)) AvatarSaver_TransferGUI.delete();
new GuiControl(AvatarSaver_TransferGUI)
{
	visible = 0;
	
	position = "0 0";
	
	new GuiWindowCtrl(AvatarSaver_TransferUI)
	{
		position = "50 50";
		extent = "270 126";
		
		closeCommand = "Canvas.popDialog(AvatarSaver_TransferGUI);";
		command = "Canvas.popDialog(AvatarSaver_TransferGUI);";
		accelerator = "Escape";
		
		text = "Avatar Transferer";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiTextCtrl()
		{
			position = "11 30";
			
			text = "Avatar Name:";
		};
		
		new GuiTextEditCtrl(AvatarSaver_TransferAvatarName)
		{
			position = "80 30";
			extent = "180 20";
		};
		
		new GuiTextEditCtrl(AvatarSaver_TransferAvatarData)
		{
			position = "10 50";
			extent = "250 50";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "10 73";
			extent = "80 20";
			
			text = "Copy Data";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "setClipboard(AvatarSaver_TransferAvatarData.getValue());";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "95 73";
			extent = "80 20";
			
			text = "Paste Data";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_TransferAvatarData.setValue(getClipboard());";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "180 73";
			extent = "80 20";
			
			text = "Clear Data";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_TransferAvatarData.setValue(\"\");";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "10 98";
			extent = "80 20";
			
			text = "Load Avatar";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarTransferer_LoadAvatar();";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "95 98";
			extent = "80 20";
			
			text = "Save Avatar";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarTransferer_SaveAvatar();";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "180 98";
			extent = "80 20";
			
			text = "Set Avatar";
			mColor = "153 153 153 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarTransferer_SetAvatar();";
		};
	};
};

function AvatarTransferer_LoadAvatar()
{
	%this = AvatarSaver_TransferAvatarName;
	%text = strReplace(%this.getValue(), " ", "_");
	%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
	for(%i=0;%i<strLen(%text);%i++)
		if(striPos(%filt, getSubStr(%text, %i, 1)) != -1)
			%name = %name@getSubStr(%text, %i, 1);
	if(%name $= "")
	{
		MessageBoxOK("Error!", "You have to put in a name to load!");
		return;
	}
	if(!isAvatar(%name))
		MessageBoxOK("Error!", "There is no avatar with that name!");
	else
	{
		%avatar = new ScriptObject() { class = "AvatarSO"; };
		%avatar.loadAvatar(%name);
		AvatarSaver_TransferAvatarData.setValue(%avatar.encodeData());
		%avatar.delete();
	}
}

function AvatarTransferer_SaveAvatar()
{
	%this = AvatarSaver_TransferAvatarName;
	%text = strReplace(%this.getValue(), " ", "_");
	%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
	for(%i=0;%i<strLen(%text);%i++)
		if(striPos(%filt, getSubStr(%text, %i, 1)) != -1)
			%name = %name@getSubStr(%text, %i, 1);
	if(%name $= "")
	{
		MessageBoxOK("Error!", "You have to put in a name to save!");
		return;
	}
	if(isAvatar(%name))
		MessageBoxYesNo("Are you sure?", "Do you want to overwrite the avatar \""@%name@"\"?", "%avatar=new ScriptObject(){class=\"AvatarSO\";};%avatar.decodeData(AvatarSaver_TransferAvatarData.getValue());%avatar.saveAvatar(%name);%avatar.delete();if($Pref::AvatarSaver::NotifyOnSave)MessageBoxOK(\"Success!\",\"Saved avatar "@%name@"!\");");
	else
	{
		%avatar = new ScriptObject() { class = "AvatarSO"; };
		%avatar.decodeData(AvatarSaver_TransferAvatarData.getValue());
		%avatar.saveAvatar(%name); %avatar.delete();
		if($Pref::AvatarSaver::NotifyOnSave)
			MessageBoxOK("Success!", "Saved avatar "@%name@"!");
	}
}

function AvatarTransferer_SetAvatar()
{
	%avatar = new ScriptObject() { class = "AvatarSO"; };
	%avatar.decodeData(AvatarSaver_TransferAvatarData.getValue());
	%avatar.setCurrentAvatar(); %avatar.delete();
	Canvas.popDialog(AvatarSaver_TransferGUI);
	Canvas.popDialog(AvatarSaverGUI);
}